# FireSpreads
Makes all wood constructions and vegetation burnable!
Dynamic fire quality reduction to reach at least target FPS.
Optimized for performance.
Playable on dedicated server.
Contains late game eternal fire weapons, a waterbomb and lightning events.
Save your world beforehand!

## Installation (manual)
- extract the content of the plugins directory into your BepInEx/plugins directory (you may create a new folder within the plugins directory)


## Features
- every wood piece becomes burnable
- vegetation becomes burnable (not ignitable with normal weapons, vegetation always drops coal)
- dynamic quality control to reach target fps
- fire may spread from fireplaces (if configured)
- eternal fire weapons
- rain may extinguish fire
- waterbomb to extinguish fires or just soak others
- ligthning events

## Client Configuration
- TargetFPS: fire quality will be reducued to reach at least target FPS (+-5)
- VisualDebug: visualize where the fire is going to spread to; for debugging only. Changing parameter during runtime will case artifacts

## Server Configuration
- WntBurnable: building pieces become burnable
- VegetationBurnable: vegetation becomes burnable
- FireSpreads: should fire spread to connected pieces
- MaxFireHealth: amount of fire damage the piece may consume before starting to burn
- FireDamage: amount of fire damage per second
- FireDamageCausesBurning: otherwise only eternal fire weapons cause burning
- LightningDamageCausesBurning: otherwise only eternal fire weapons cause burning
- FireSpreadDamage: amount of fire spread damage against MaxFireHealth per second
- ConnectedNonBurnableDamage: burning pieces apply this amount of damage per second to connected non burning pieces
- ReducedWetFactor: percentage fire damage is reduced to when wet (rain or snow)
- IncreasedWindFactor: faster spreading under windy conditions
- BurningDropsCoal: burning pieces only drop coal when destroyed
- StopBurningHealthPercentage: stop burning if health is below this percentage (0-1)
- SpreadFromFireplaces: if true, fire may spread from fireplaces
- UpwardSpreadMultiplier: increased fire spread upwards
- EternalFlameWeaponsCraftable: shall the eternal fire weapons be craftable
- WaterBombCraftable: should the waterbomb be craftable?
- MaxBurningPieces: limit the number of burning pieces per scene
- CalculationBatchSize: internal parameter; how many pieces to process per frame
- FireSpreadDistance: distance to other pieces the fire may spread to
- RainExtinguishesProbability: probability rainy weather extinguish fire (per piece per state update)
- RainExtinguishesCovered: probability rain extinguishes fire on pieces under cover
- TreeBurnRadius: factor for the distance player starts to burn near trees (needs restart)
- EventImmediateFire: fire/ligthning hit damage immediately ignites fire during these events
- NonBurnablePrefabs: names of prefabs that should not be burnable (comma separated list)
- EventThunderstruckBiome: Event ThunderStruck biomes
- EventThunderstruckDuration: Event ThunderStruck duration in sec
- EventThunderstruckReqGlobKey: Event ThunderStruck required GlobKeys (, separated)
- EventThunderstruckNotReqGlobKey: Event ThunderStruck not required GlobKeys (, separated)
- EventThunderstruckSpawnInterval: Event ThunderStruck lightning interval in sec
- EventThunderstruckMinSpawnRadius: Event ThunderStruck lightning min spawn radius
- EventThunderstruckMaxSpawnRadius: Event ThunderStruck lightning max spawn radius
- EventThundersnowBiome: Event ThunderSnow biomes
- EventThundersnowDuration: Event ThunderSnow duration in sec
- EventThundersnowReqGlobKey: Event ThunderSnow required GlobKeys (, separated)
- EventThundersnowNotReqGlobKey: Event ThunderSnow not required GlobKeys (, separated)
- EventThundersnowSpawnInterval: Event ThunderSnow lightning interval in sec
- EventThundersnowMinSpawnRadius: Event ThunderSnow lightning min spawn radius
- EventThundersnowMaxSpawnRadius: Event ThunderSnow lightning max spawn radius
- EventThunderstormdryBiome: Event ThunderStormDry biomes
- EventThunderstormdryDuration: Event ThunderStormDry duration in sec
- EventThunderstormdryReqGlobKey: Event ThunderStormDry required GlobKeys (, separated)
- EventThunderstormdryNotReqGlobKey: Event ThunderStormDry not required GlobKeys (, separated)
- EventThunderstormdrySpawnInterval: Event ThunderStormDry lightning interval in sec
- EventThunderstormdryMinSpawnRadius: Event ThunderStormDry lightning min spawn radius
- EventThunderstormdryMaxSpawnRadius: Event ThunderStormDry lightning max spawn radius

## Dependencies
- BepInEx
- Jotunn, the Valheim Library